- **Source**
  - [Data Structures and Algorithms in JavaScript](https://github.com/amejiarosario/dsa.js-data-structures-algorithms-javascript#-algorithms-analysis) - алгоритмы, структуры, анализ скорости, graph, tree
  - [Leetcode Patterns](https://seanprashad.com/leetcode-patterns/) - паттерны какой алгоритм в каких случаях лучше выбрать для решения leetcode
  - [Top 75 LeetCode Questions to Save Your Time](https://www.teamblind.com/post/New-Year-Gift---Curated-List-of-Top-100-LeetCode-Questions-to-Save-Your-Time-OaM1orEU)
  - [Grokking the Coding Interview](https://www.designgurus.io/course/grokking-the-coding-interview)
  - [14 Patterns to Ace Any Coding Interview Question](https://hackernoon.com/14-patterns-to-ace-any-coding-interview-question-c5bb3357f6ed)
  - [Bit Twiddling Hacks](https://graphics.stanford.edu/~seander/bithacks.html) - сборник алгоритмов операций с битами
  - [Amit’s A* Pages](http://theory.stanford.edu/~amitp/GameProgramming/) - алгоритмы поиска пути и как их реализовать и какие структуры использовать, описание оптимизаций
  - [How to think in graphs: An illustrative introduction to Graph Theory and its applications](https://medium.com/free-code-camp/i-dont-understand-graph-theory-1c96572a1401) - графы и деревье, простое наглядно, примеры реализации, по категориям
  - [Algorithms Behind Modern Storage Systems](https://queue.acm.org/detail.cfm?id=3220266) - какие структуры и алгоритмы как и когда используют в реальных системах
  - statistics
    - [15 Types of Regression in Data Science](https://www.listendata.com/2018/03/regression-analysis.html)
  - [javatpoint Boolean algebra & basics of Digital Electronics](https://www.javatpoint.com/laws-and-rules-of-boolean-algebra-in-digital-electronics)
- **Math**
  - Дискретная математика: формулы перестановок и сочетаний
  - Boolean algebra: De Morgan's laws, Peirce's law, Clavius's Law etc, Karnaugh map
  - Процентили и квартили
  - Probability: Bayes' theorem, Expected value, формулы теории вероятности
  - Бином Ньютона
  - Разложение в ряды
  - Алгебра: арифметическая и геометрическая прогрессии, логарифмы
  - Геометрия: площади фигур, длины сторон, cos, sin, tg, ctg, расстояние между точками, мнимые числа
- **Task**
  - НОД
  - НОК
  - Функция обмена двух переменных
  - Факториал числа
  - Сумма цифр числа
  - Числа Фибоначчи
  - Числа Мерсенна
  - Арифметическая прогрессия
  - Геометрическая прогрессия
  - Факториал
  - Код Грея
  - Биномиальный коэффициент
- **Algorithms**
  - greedy
  - sliding window
  - dfs
  - bfs
  - backtracking (bf)
  - dynamic programming
  - heap / priority queue
  - quick sort
  - quick select
  - topological order
  - union find (disjoint set union)
  - intervals
  - monotonic stack (inc/dec)
  - minimum spanning tree (mst, prim's algorithm)
  - djikstra
  - binary-indexed-tree (fanvic-tree)
  - segment tree (interval tree)
  - bitwise
  - bellman-ford
  - A-star
- **Structures**
  - simple
    - представление графа
      - Adjacency matrix
      - Adjacency list
      - Incidence matrix
      - doubly connected edge list (DCEL)
    - queue
    - stack
    - linked list
    - hash table
    - hash set
    - tree set
    - hash map
    - tree map
    - LRU Cache
  - tree
    - Binary Trees
    - Binary Search Trees (BST)
    - AVL Trees ((Adelson-Velsky and Landis)
    - Red-Black Trees
- **What to choose?**
  - If input array is sorted then
    - Binary search
    - Two pointers
  - If asked for all permutations/subsets then
    - Backtracking
  - If given a tree then
    - DFS
    - BFS
  - If given a graph then
    - DFS
    - BFS
  - If given a linked list then
    - Two pointers
  - If recursion is banned then
    - Stack
  - If must solve in-place then
    - Swap corresponding values
    - Store one or more different values in the same pointer
  - If asked for maximum/minimum subarray/subset/options then
    - Dynamic programming
  - If asked for top/least K items then
    - Heap
    - QuickSelect
  - If asked for common strings then
    - Map
    - Trie
  - Else
    - Map/Set for O(1) time & O(n) space
    - Sort input for O(nlogn) time and O(1) space